var wn = angular.module('wn',[]);

//加载动画
wn.directive('loadingsvg',function(){
    return {
        restrict:'E',
        templateUrl:'lib/wn/loadingsvg.html',
    };
});

//无网络提示栏
wn.directive('offlinenotice',function(){
    return {
        restrict:'E',
        templateUrl:'lib/wn/offlinenotice.html',
    };
});

//检测网络状态
wn.directive('checknet',function(){
    return{
        restrict:'AE',
        link:function(scope,element,attr){
            clearInterval(checkNetWorkInter);
            //checkNetWork(scope);
            checkNetWorkInter = setInterval(function(){
                checkNetWork(scope);
                //console.log('link:'+scope.Sys_status);
            },5000);
        },
    };
    
});

//退出软件提示框
wn.directive('exitready',function(){
    return {
        restrict:'AE',
        templateUrl:'lib/wn/exitready.html',
    };
});

//加载配置
wn.directive('config',function(){
    return {
        restrict:'E',
        link:function(scope){
            scope._config = AG_CONFIGS;
            scope.setUrlTag = function(ks,def){
                def = def?def:'';
                var str = 'scope.' + ks + ' = ' + 'scope.' + ks + '?AG_CONFIGS.httpHost + ' + 'scope.' + ks + ':def';
                //alert(str);
                eval('(' + str + ')');
                //v = v?AG_CONFIGS.httpHost + v:def;
                //alert(v);
            }
            scope.setUrlTags = function(list,k,def){
                def = def?def:'';
                angular.forEach(list,function(m,i){
                    if(k){
                        m[k] = m[k]?AG_CONFIGS.httpHost + m[k].replace(AG_CONFIGS.httpHost,''):def;
                    }else{
                        list[i] = list[i]?AG_CONFIGS.httpHost + list[i].replace(AG_CONFIGS.httpHost,''):def;
                    }
                });
            }

            //console.log(scope._config);
        }
    };
});

//公共顶部栏
wn.directive('topcommon',function(){
    return {
        restrict:'A',
        templateUrl:'lib/wn/topcommon.html',
        link:function(scope,element,attr){
            element.find('.title').html(attr.topcommon);;
        }
    };
});

//修正图片地址
wn.directive('reloadimg',function(){
    return {
        restrict:'A',
        link:function(scope,element,attr){
            element.find('img').bind('onerror',function(){
                this.src = scope._config.httpHost + this.src;
            });
        }
    };
});

//高度随宽度变化
wn.directive('heightrate',function(){
    return {
        restrict:'A',
        transclude:1,
        templateUrl:'lib/wn/heightrate.html',
        link:function(scope,element,attr){
            if(attr.heightrate)
            element.find('div[name="padding_height_div"]').css('padding-top',attr.heightrate);
        }
    };
});


//聚焦指令
wn.directive('focus',function(){
    return {
        restrict:'A',
        link:function(scope,element,attr){
            var bindval = attr.focus;
            if(scope[bindval]){
                element.focus();
            }
            $(document).click(function(){
                //alert(scope[bindval]);
                if(scope[bindval]){
                    var timer = setTimeout(function(){
                        element.focus();
                    },100);
                }
            });
        }
    };
});

//协议&显示浮动
wn.directive('agreefloat',function(){
    return {
        restrict:'AE',
        templateUrl:'lib/wn/agreefloat.html',
        controller:function($scope,$http){
            //弹出协议浮动框
            this.showPop = function(){
                $scope.agreement_show = 1;
                if(!$scope.agreement){
                    var type = $scope.agreement_type;
                    type = type?type:0;
                    var data = {
                        type:type
                    };
                    $http.post(AG_CONFIGS.httpHost + '/index.php/platform/agreement/getinfo',data).success(function(data){
                        $scope.agreement = data.msg;
                        //console.log(data);
                    });
                }
            };

            //隐藏协议浮动框
            this.hidePop = function(){
                $scope.agreement_show = 0;
            }
        },
        link:function(scope,element,attr,ctrl){
            scope.agreement_type = attr.type;
            switch(scope.agreement_type){
                case '1':
                    scope.agreement_type_name = scope._config.userRegAgreement;
                    break;
                case '2':
                    scope.agreement_type_name = scope._config.businessRegAgreement;
                    break;
            }
            scope.showPop = ctrl.showPop;
            scope.hidePop = ctrl.hidePop;
        }
    };
});

//爱心公益图浮动
wn.directive('loveactivity',function(){
    return {
        restrict:'AE',
        templateUrl:'lib/wn/loveactivity.html',
        controller:function($scope,$http){
            //弹出协议浮动框
            this.showActivity = function(){
                $scope.activity_show = 1;
                /*if(!$scope.agreement){
                    var type = $scope.agreement_type;
                    type = type?type:0;
                    var data = {
                        type:type
                    };
                    $http.post(AG_CONFIGS.httpHost + '/index.php/platform/agreement/getinfo',data).success(function(data){
                        $scope.agreement = data.msg;
                        //console.log(data);
                    });
                }*/
            };

            //隐藏协议浮动框
            this.hideActivity = function(){
                $scope.activity_show = 0;
            }
        },
        link:function(scope,element,attr,ctrl){
            scope.showActivity = ctrl.showActivity;
            scope.hideActivity = ctrl.hideActivity;
            scope.actrand = new Date().getTime();
        }
    };
});

wn.directive('baidulocation',function(){
    return {
        restrict:'E',
        link:function(){
            var getloctimes = 0;
            function baidu_getlocation(cyc){
                getloctimes ++;
                //console.log('=========== baidu_getlocation =============');
                if(cyc){
                    var act = baidu_jsloc;
                }else{
                    var act = function(){
                        //console.log('--------- get location fail ----------');
                    }
                }
                var flag = 1;
                navigator.geolocation.getCurrentPosition(function(position){
                    flag = 0;
                    localStorage.lng = position.coords.longitude;
                    localStorage.lat = position.coords.latitude;
                    if(getloctimes%5 == 0){
                        baidu_getcity(localStorage.lng,localStorage.lat);
                    }
                },act);
                var timer = setTimeout(function(){
                    clearTimeout(timer);
                    if(flag) act();
                },1000);
            }

            function baidu_jsloc(){
                //alert('定位失败，使用js定位');
                var map = new BMap.Map("allmap");

                var geolocation = new BMap.Geolocation();
                geolocation.getCurrentPosition(function(r){
                    //alert('您的位置：'+r.point.lng+','+r.point.lat);
                    localStorage.lng = r.point.lng;
                    localStorage.lat = r.point.lat; 
                    //baidu_getcity(r.point.lng,r.point.lat);
                    //alert('js:  lat-'+r.point.lat+' lng-'+r.point.lng);
                },{enableHighAccuracy: true});
            }

            function baidu_getcity(lng,lat){
                var url = 'http://api.map.baidu.com/geocoder/v2/?location='+lat+','+lng+'&output=json&pois=1&ak=iYa9R6hihlCqKTF3tQpUO08QsllGRzcE&mcode=98:04:60:A6:7F:EE:C9:A1:66:63:72:C3:CE:06:72:7F:DE:6B:64:8F;xinykj.com.yinglian1129';
                $.ajax({
                    url:url,
                    data:{},
                    type:'GET',
                    dataType:'json',
                    success:function(data){
                        console.log(data);
                        if(!data.status) {
                            localStorage.city = data.result.addressComponent.city?data.result.addressComponent.city:'';
                        }
                        //alert(data.result.formatted_address);
                    }
                });
            }

            //console.log('storage: lat '+ localStorage.lat + ',lng ' + localStorage.lng);

            baidu_getlocation(1);
            setInterval(function(){
                if(localStorage.lng) baidu_getlocation();
            },60000);
        }
    };
});

// //更新地址位置
// wn.factory('baiduloca',function($interval){
//     return {
//         inter:function(){
//             $interval(function(){
//                 alert(1);
//             },3000);

//         }
//     };

// });